/******************************************************************************
  (c) Copyright 2009, 1060 Research Ltd                                        

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      

  $Id$
 *****************************************************************************/
package org.netkernel.xml.saxon.accessor.xquery;

import javax.xml.transform.stream.StreamSource;

import net.sf.saxon.lib.ModuleURIResolver;
import net.sf.saxon.trans.XPathException;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;

/**
 * NetKernel aware ModuleURIResolver for Saxon9.
 * 
 * @author Chris Cormack
 * @author Menzo Windhouwer
 */
public class NKModuleURIResolver implements ModuleURIResolver
{
	private INKFRequestContext mContext = null;

	public NKModuleURIResolver(INKFRequestContext aContext)
	{
		mContext = aContext;
	}

	public StreamSource[] resolve(String moduleURI, String baseURI,
			String[] locations) throws XPathException
	{	try
		{	IReadableBinaryStreamRepresentation aStream = null;
			String aURI = null;
			for (int i = 0; i < locations.length; i++)
			{	aURI = locations[i];
				aStream = (IReadableBinaryStreamRepresentation) mContext
						.source(aURI.toString(),
								IReadableBinaryStreamRepresentation.class);
				if (aStream != null)
					break;
			}

			if (aStream != null)
			{	StreamSource[] res = new StreamSource[1];
				res[0] = new StreamSource(aStream.getInputStream(), aURI);
				return res;
			} else
			{	throw new XPathException(
						"can't create a StreamSource for XQuery Module URI["
								+ moduleURI + "] at [" + aURI + "]");
			}
		} catch (Exception e)
		{	throw new XPathException(e);
		}
	}
}
